@ECHO off
REM ------------------------------------------------------------
REM Name:  svn-updater.cmd (Ver. 1.0 - 29.08.2011)
REM Autor: Daniel "Boehrsi" B. (www.Boehrsi.de / mail@boehrsi.de)
REM Lizenz: https://creativecommons.org/licenses/by-sa/3.0/de/
REM ------------------------------------------------------------

REM Log Level des SVN Clients einstellen (1: alles inkl. Informationen zu aktualisierten Dateien, 0: nur Fehler)
SET loglevel=1
REM Fehler Level des SVN Clients einstellen (1: aktivieren, 0: deaktivieren und nur die Ausgabe des Scripts aktiviert lassen)
SET errlevel=1
REM Working Copy URL anzeigen
SET wc=0
REM SVN Log Eintrge in der Script Log Datei anzeigen (1: aktivieren, 0: deaktivieren)
SET svnlog=1

REM Bitte keine nderungen ab dieser Zeile vornehmen, es sei denn du weisst was du tust

REM Globale Variablen setzen
SET cdate=%DATE% - %TIME%
SET inf001=________________________________________________________________________
SET inf002=SVN CMD Client wird getestet - Version:
SET inf003=Update war erfolgreich oder es gab keine neue Version

REM Fehler Variablen setzen
SET err001=FEHLER [001] Kein SVN CMD Client gefunden 
SET err002=FEHLER [002] Die SVN Listen Datei svnlist.txt existiert nicht im Verzeichnis
SET err003=FEHLER [003] Update des SVNs schlug fehl

REM Log Datei wird geschrieben und Programmstart dokumentiert
echo ^> SVN Multiupdater gestartet [%cdate%] >> log.txt

REM SVN Client wird geprft
echo ^> %inf002% >> log.txt
svn --version --quiet 2> NUL >> log.txt
if ERRORLEVEL 1 (
	echo ^> %err001% >> log.txt
	exit
)

REM Config Datei wird geprft
IF NOT EXIST svnlist.txt ( 
	echo ^> %err002% >> log.txt
	exit
)

REM Config Eintrge werden abgearbeitet

for /f "delims=" %%i in (svnlist.txt) do (
	echo.>> log.txt
	echo ^> Update fuer %%i wird durchgefuehrt >> log.txt
	IF %wc% == 1 (
		svn info "%%i" | findstr URL >> log.txt
	)
	
	REM Version vor dem Update abfragen
	IF %svnlog% == 1 (
		FOR /F "tokens=*" %%j IN ('svn info "%%i" ^| findstr "Revision"') DO SET prever=%%j
	)
	
	REM Update Befehl ausfhren und prfen ob dieser erfolgreich war
	IF %loglevel% == 1 (
		IF %errlevel% == 1 (
			svn update "%%i" >> log.txt 2>>&1  
		) ELSE (
			svn update "%%i" >> log.txt 2>> NUL
		)
	) ELSE (
		IF %errlevel% == 1 (
			svn update "%%i" >> NUL 2>> log.txt  
		) ELSE (
			svn update "%%i" >> NUL 2>> NUL
		)
	)

	REM Prfung ob das Update erfolgreich verlief
	IF ERRORLEVEL 1 (
		echo ^> %err003% >> log.txt
	) else (
		echo ^> %inf003% >> log.txt
	)
	
	REM Version nach dem Update abfragen
	IF %svnlog% == 1 (
		FOR /F "tokens=*" %%k IN ('svn info "%%i" ^| findstr "Revision"') DO SET postver=%%k

	REM SVN Log Eintrge in die Script Log Datei schreiben
		Setlocal EnableDelayedExpansion 
		if not !prever:~10! == !postver:~10! (
			SET /a fixedprever=!prever:~10!+1
			FOR /F "tokens=*" %%l IN ('svn log "%%i" -r !fixedprever!:!postver:~10! ^| findstr [a-z]') DO echo %%l >> log.txt
		)
		Endlocal
	)

)

echo %inf001% >> log.txt
echo. >> log.txt
@ECHO on